Thank you for opening a PR to riscemu, your contribution is highly appreciated!

We've put together two checklists below to make sure the review and merge process goes as smoothly as possible. Please make sure that you complete the writing checklist before opening the PR. Please feel free to delete it once you completed it.

The pre-merge checklist is here so that you can see roughly what is expected of a PR to be merged. Not every step is always required, but checking all the boxes makes it almost certain that your PR will be merged swiftly. Feel free to leave it in the PR text, or delete it, it's up to you!

Good luck with the PR!


**PR Writing Checklist:**

 - [ ] If I'm referencing an Issue, I put the issue number in the PR name
 - [ ] I wrote a paragraph explaining my changes and the motivation
 - [ ] If this PR is not ready yet for review, I mark it as draft
 - [ ] Delete this checklist before opening the PR


**Pre-Merge Checklist:**

 - [ ] I added an entry to the `CHANGELOG.md`
 - [ ] I added a test that covers my change
 - [ ] I ran the pre-commit formatting hooks
 - [ ] CI Passes
